#!/bin/bash

#############################################################
# Metiix Blockade Server for Linux Uninstaller Script
#############################################################

# ENVIRONMENT
BASEDIR=`pwd`
ROOT_USER=n

# requirements
REQDBINS="grep sed tar gzip cut head tail who"

# base directories
OPTDIR=/opt/blockade
ETCDIR=/etc
INITDIR=/etc/init.d

RUNLEVEL=`who -r | sed -e 's/^.*\(run-level [0-9]\).*$/\1/' | cut -d \  -f 2`
RUNLVLDIR=/etc/rc${RUNLEVEL}.d

QUIET=1
INSTALLDIR=""
USERNAME="`id -un`"

while getopts "?qi:" OPT; do
	case $OPT in
		q)
			QUIET=0
			;;
		i)
			INSTALLDIR="$OPTARG"
			;;
		?)
		echo "Usage: uninstall.sh -i <installation_dir>"
		exit 1
			;;
	esac
done

if [[ -n $INSTALLDIR ]]; then
	OPTDIR=$INSTALLDIR
fi

if [[ ! -f $OPTDIR/.install.vars ]]; then
	echo ""
	echo "Metiix Blockade Server was not found at $OPTDIR.  Please specify where the server was installed."
fi


echo ""
echo "Metiix Blockade Server Uninstaller."
echo ""
echo -n "Press enter to continue. "
read ENTER

agreed=0
while [[ "${agreed}" == "0" ]]; do
	if [[ "${USERNAME}" != "root" ]]; then
		echo ""
		echo "NOTE: You are apparently not uninstalling as root.  You will not be "
		echo "able to clean up all the necessary files created by your server installation."
		echo ""
		echo -n "Would you like to switch users and uninstall as root? (y/n) [y] "
		read YN
		if [[ -z $YN ]]; then
			YN="y"
		fi

		case ${YN} in
			[yY] | [yY][eE][sS])
				echo ""
				echo "Switching to root to continue uninstallation"
				sudo $0 -q -i $INSTALLDIR
				exit 0
				;;
			[nN] | [nN][oO])
				echo "  uninstalling as $USERNAME"
				agreed=1
				;;
		esac
	else
		echo "    detected root uninstallation"
		ROOT_USER=y
		agreed=1
	fi
done


echo "  reviewing required executables ..."
echo -n "    "
for BIN in $REQDBINS ; do

	BIN_PATH=`which $BIN 2> /dev/null`
	if [[ $? != 0 ]]; then
		echo ""
		echo "$BIN not found and is required. Installation will exit."
		exit 1
	fi
done

echo ""
echo "============================================================================"
echo "Metiix Blockade Server Removal"
echo "============================================================================"
echo ""
echo -n "Are you sure you wish to continue? (yes/no) [no] "
read YN
if [[ -z $YN ]]; then
	YN="no"
fi

if [[ "${YN}" == "yes" ]]; then
	echo
	echo "Uninstalling Metiix Blockade Server ... "
	. $OPTDIR/.install.vars
	if [[ -z $OPTDIR ]]; then
		echo "ERROR: Conf file not loaded correctly. Unable to uninstall automatically."
		exit 1
	fi

	echo "  stopping the server"
	$INITDIR/blockade stop

	echo "  removing files"
	rm -rf $OPTDIR
	rm -rf $INITDIR/blockade
	rm -rf $RUNLVLDIR/S99blockade
	rm -rf $RUNLVLDIR/S02blockade

	echo ""
	echo "Metiix Blockade Server uninstalled. Exiting."
	echo ""
fi
exit 0

echo ""
echo "Uninstall complete."
echo
